# Copyright (c) 2000-2007, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define _with_repolib 1

# If you want repolib package to be built,
# issue the following: 'rpmbuild --with repolib'
%define with_repolib %{?_with_repolib:1}%{!?_with_repolib:0}
%define without_repolib %{!?_with_repolib:1}%{?_with_repolib:0}

%define repodir %{_javadir}/repository.jboss.com/jboss/cache/%{version}.%{reltag}-brew
%define repodirlib %{repodir}/lib
%define repodirsrc %{repodir}/src

# If you want to built without jdk15 support, 
# give rpmbuild option '--without jdk15'
%define without_jdk15 %{?_without_jdk15:1}%{!?_without_jdk15:0}
%define with_jdk15 %{!?_without_jdk15:1}%{?_without_jdk15:0}

# If you want to built with unit tests, give rpmbuild option '--with tests'
%define with_tests %{?_with_tests:1}%{!?_with_tests:0}
%define without_tests %{!?_with_tests:1}%{?_with_tests:0}

%define section  free

%define reltag  SP8_CP01

Summary:        JBoss Cache
Name:           jboss-cache
Version:        1.4.1
Release:        4.SP8_CP01.1jpp.ep1.1%{?dist}
Epoch:          0
License:        LGPL
Group:          Internet/WWW/Servers
URL:            http://www.jboss.org/
# svn export https://svn.jboss.org/repos/jbosscache/core/cp_tags/1.4.1.SP8_CP01/ JBossCache-1.4.1.SP8_CP01-src
# tar czf JBossCache-1.4.1.SP8_CP01-src.tar.gz JBossCache-1.4.1.SP8_CP01-src
Source0:        JBossCache-1.4.1.SP8_CP01-src.tar.gz
Source1:        jboss-cache-README.txt
Source2:	jboss-cache-component-info.xml

# FIXME must adjust this patch to force IPv4 to be used on Linux
Patch1:		jboss-cache-1.3.0.2-build_xml.patch
Patch2:		jboss-cache-GlobalTransactionTest.patch

BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root
BuildArch:      noarch
# tool requires
BuildRequires:       jpackage-utils >= 0:1.6
BuildRequires:       ant >= 0:1.6.2
BuildRequires:       ant-javamail
BuildRequires:       ant-junit
BuildRequires:       ant-nodeps
BuildRequires:       ant-trax
BuildRequires:       ant-xslp
BuildRequires:       bsf
BuildRequires:       junit
BuildRequires:       xalan-j2
BuildRequires:       xerces-j2
BuildRequires:       xml-commons-apis
BuildRequires:       xml-commons-resolver
%if %{with_jdk15}
BuildRequires:       java-1.5.0-devel
%else
BuildRequires:       java-1.4.2-devel
%endif
# other requires
BuildRequires:       bsh2 >= 0:2.0-0.b4
BuildRequires:       berkeleydb
BuildRequires:       concurrent
BuildRequires:       dom4j
BuildRequires:       derby
BuildRequires:       gnu.trove
BuildRequires:       jakarta-commons-logging
BuildRequires:       javassist
BuildRequires:       jboss-aop
BuildRequires:       jboss-jrunit
BuildRequires:       jboss-common
BuildRequires:       jboss-serialization
BuildRequires:       jbossas
BuildRequires:       jdbm
BuildRequires:       jcommon
BuildRequires:       jfreechart
BuildRequires:       jgroups
BuildRequires:       log4j
BuildRequires:       qdox >= 0:1.5

Requires:       berkeleydb
Requires:       concurrent
Requires:       jakarta-commons-logging
Requires:       jboss-aop
Requires:       jboss-common
Requires:       jbossas
Requires:       jgroups
Requires:       xml-commons-apis

%description
JBoss Cache is a product designed to cache frequently accessed 
Java objects in order to dramatically improve the performance 
of e-business applications. By eliminating unnecessary database 
access, JBoss Cache decreases network traffic and increases the 
scalability of applications.
JBoss Cache provides two caching APIs to suit your needs. The 
JBossCache API offers a traditional, tree-structured node-based 
cache and the JBossCacheAOP API, which builds on the JBossCache 
API, provides the ability to perform fine-grained replication 
of Java objects, resulting in maximum performance benefits. 


%if %{with_repolib}
%package	 repolib
Summary:	 Artifacts to be uploaded to a repository library
Group:	Development/Libraries/Java

%description	 repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio
%endif

%package        javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation
BuildRequires:  java-javadoc

%description    javadoc
%{summary}.

%package        manual
Summary:        Documents for %{name}
Group:          Development/Documentation

%description    manual
%{summary}.

%prep
%setup -qq -n JBossCache-1.4.1.SP8_CP01-src

# FIXME must adjust this patch to force IPv4 to be used on Linux
#%patch1 -b .sav
%patch2 -b .sav
#%if %{without_jdk15}
#%patch4 -b .sav
#%patch5 -b .sav
#%endif

# Clean binary JARs
for f in $(find . -name "*.jar"); do
	mv $f $f.no
done

pushd ant-dist/lib
#BUILD/JBossCache-1.3.0.1-src/ant-dist/lib/ant.jar.no
ln -sf $(build-classpath ant) .
#BUILD/JBossCache-1.3.0.1-src/ant-dist/lib/ant-junit.jar.no
ln -sf $(build-classpath ant/ant-junit) .
#BUILD/JBossCache-1.3.0.1-src/ant-dist/lib/ant-launcher.jar.no
ln -sf $(build-classpath ant-launcher) .
#BUILD/JBossCache-1.3.0.1-src/ant-dist/lib/ant-nodeps.jar.no
ln -sf $(build-classpath ant/ant-nodeps) .
#BUILD/JBossCache-1.3.0.1-src/ant-dist/lib/ant-trax.jar.no
ln -sf $(build-classpath ant/ant-trax) .
#BUILD/JBossCache-1.3.0.1-src/ant-dist/lib/ant-xslp.jar.no
ln -sf $(build-classpath ant/ant-xslp) .
#BUILD/JBossCache-1.3.0.1-src/ant-dist/lib/bsf.jar.no
ln -sf $(build-classpath bsf) .
#BUILD/JBossCache-1.3.0.1-src/ant-dist/lib/junit.jar.no
ln -sf $(build-classpath junit) .
#BUILD/JBossCache-1.3.0.1-src/ant-dist/lib/pretty.jar.no
#
#BUILD/JBossCache-1.3.0.1-src/ant-dist/lib/resolver.jar.no
ln -sf $(build-classpath xml-commons-resolver) resolver.jar
popd
pushd lib-50
#BUILD/JBossCache-1.3.0.1-src/lib-50/jboss-aop-jdk50.jar.no
#
popd
pushd lib
#BUILD/JBossCache-1.3.0.1-src/lib/bsh-2.0b4.jar.no
ln -sf $(build-classpath bsh2/bsh-core) .
ln -sf $(build-classpath bsh2/bsh-util) .
#BUILD/JBossCache-1.3.0.1-src/lib/commons-logging.jar.no
ln -sf $(build-classpath commons-logging) .
#BUILD/JBossCache-1.3.0.1-src/lib/concurrent.jar.no
ln -sf $(build-classpath concurrent) .
#
ln -sf $(build-classpath dom4j) .
#BUILD/JBossCache-1.3.0.1-src/lib/derby.jar.no
ln -sf $(build-classpath derby/derby) .
#BUILD/JBossCache-1.3.0.1-src/lib/javassist.jar.no
ln -sf $(build-classpath javassist) .
#BUILD/JBossCache-1.3.0.1-src/lib/jboss-aop.jar.no
ln -sf $(build-classpath jboss-aop/jboss-aop) .
#BUILD/JBossCache-1.3.0.1-src/lib/jboss-common.jar.no
ln -sf $(build-classpath jboss-common/jboss-common) .
#BUILD/JBossCache-1.3.0.1-src/lib/jboss-j2ee.jar.no
ln -sf $(build-classpath jbossas/jboss-j2ee) .
#BUILD/JBossCache-1.3.0.1-src/lib/jboss-jmx.jar.no
ln -sf $(build-classpath jbossas/jboss-jmx) .
#BUILD/JBossCache-1.3.0.1-src/lib/jboss-minimal.jar.no
ln -sf $(build-classpath jbossas/jboss-minimal) .
#BUILD/JBossCache-1.3.0.1-src/lib/jboss-serialization.jar.no
ln -sf $(build-classpath jboss-serialization) .
#BUILD/JBossCache-1.3.0.1-src/lib/jboss-system.jar.no
ln -sf $(build-classpath jbossas/jboss-system) .
#BUILD/JBossCache-1.3.0.1-src/lib/jdbm-1.0.jar.no
ln -sf $(build-classpath jdbm) .
#BUILD/JBossCache-1.3.0.1-src/lib/jcommon-1.0.0-rc1.jar.no
ln -sf $(build-classpath jcommon) .
#BUILD/JBossCache-1.3.0.1-src/lib/jfreechart-1.0.0-rc1.jar.no
ln -sf $(build-classpath jfreechart) .
#BUILD/JBossCache-1.3.0.1-src/lib/jgroups.jar.no
ln -sf $(build-classpath jgroups) .
#BUILD/JBossCache-1.3.0.1-src/lib/jrunit.jar.no
ln -sf $(build-classpath jboss-jrunit) jrunit.jar
#BUILD/JBossCache-1.3.0.1-src/lib/junit.jar.no
ln -sf $(build-classpath junit) .
#BUILD/JBossCache-1.3.0.1-src/lib/log4j.jar.no
ln -sf $(build-classpath log4j) .
#BUILD/JBossCache-1.3.0.1-src/lib/qdox.jar.no
ln -sf $(build-classpath qdox) .
#BUILD/JBossCache-1.3.0.1-src/lib/trove.jar.no
ln -sf $(build-classpath gnu.trove) trove.jar
pushd sleepycat
#BUILD/JBossCache-1.3.0.1-src/lib/sleepycat/je.jar.no
ln -sf $(build-classpath berkeleydb) je.jar
popd
popd

sed -i 's/@VERSION@/%{version}.%{reltag}-brew/g' %{SOURCE2}
tag=`echo %{name}-%{version}-%{release} | sed 's|\.|_|g'`
sed -i "s/@TAG@/$tag/g" %{SOURCE2}

%build

BUILD_ID=`date -u +%Y%m%d%H%M`_%{version}-%{release}

%if %{with_jdk15}
export JAVA_HOME=/usr/lib/jvm/java-1.5.0
%else
export JAVA_HOME=/usr/lib/jvm/java-1.4.2
%endif
export CLASSPATH=""

%if %{with_tests}
export ANT_OPTS="-Djava.net.preferIPv4Stack=true"
ant \
	-Djunit.timeout.performance=90000 \
	-Djunit.timeout=750000 \
	jar javadocs unittests
%else
ant jar javadocs
%endif

%install
rm -rf $RPM_BUILD_ROOT

install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/%{name}

# jars
install -m 644 dist/lib/jboss-cache.jar $RPM_BUILD_ROOT%{_javadir}/jboss-cache-%{version}.jar
%if %{with_jdk15}
install -m 644 dist/lib-50/jboss-cache-jdk50.jar $RPM_BUILD_ROOT%{_javadir}/jboss-cache-jdk50-%{version}.jar
%endif

# create all versionless symlinks
(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)


# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr output/api/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name}

# -----------------------------------------------------------------------------
# manual
install -d -m 755 $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp -pr docs/* $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}



%if %{with_repolib}
	install -d -m 755 $RPM_BUILD_ROOT%{repodir}
	install -d -m 755 $RPM_BUILD_ROOT%{repodirlib}
	install -m 755 %{SOURCE2} $RPM_BUILD_ROOT%{repodir}/component-info.xml
	install -m 755 %{SOURCE1} $RPM_BUILD_ROOT%{repodir}/README.txt
	install -d -m 755 $RPM_BUILD_ROOT%{repodirsrc}
	install -m 755 %{SOURCE0} $RPM_BUILD_ROOT%{repodirsrc}
	install -m 755 %{PATCH2} $RPM_BUILD_ROOT%{repodirsrc}
	cp $RPM_BUILD_ROOT%{_javadir}/jboss-cache-jdk50.jar $RPM_BUILD_ROOT%{repodirlib}
%endif

%clean
rm -rf $RPM_BUILD_ROOT

# -----------------------------------------------------------------------------

%post javadoc
rm -f %{_javadocdir}/%{name}
ln -s %{name}-%{version} %{_javadocdir}/%{name}

%postun javadoc
if [ "$1" = "0" ]; then
    rm -f %{_javadocdir}/%{name}
fi

%files
%defattr(0644,root,root,0755)
%{_javadir}/jboss-cache-%{version}.jar
%{_javadir}/jboss-cache.jar
%if %{with_jdk15}
%{_javadir}/jboss-cache-jdk50-%{version}.jar
%{_javadir}/jboss-cache-jdk50.jar
%endif

%files javadoc
%defattr(0644,root,root,0755)
%doc %{_javadocdir}/%{name}-%{version}
%ghost %doc %{_javadocdir}/%{name}

%files manual
%defattr(0644,root,root,0755)
%doc %{_docdir}/%{name}-%{version}


# -----------------------------------------------------------------------------


%if %{with_repolib}
%files repolib
%defattr(0644,root,root,0755)
%{repodir}
%endif

%changelog
* Wed Jan 23 2008 Fernando Nasser <fnasser@redhat.com> 0:1.4.1-4.SP8_CP01.1jpp.ep1.1
- Upgrade to SP8_CP01

* Wed Jan 02 2008 Fernando Nasser <fnasser@redhat.com> 0:1.4.1-3.SP8_patch02.1jpp.ep1.1
- Proper fix for JBCACHE-1246

* Wed Dec 12 2007 Fernando Nasser <fnasser@redhat.com> 0:1.4.1-3.SP8_patch01.1jpp.ep1.1
- Fix for JBCACHE-1246

* Wed Dec 12 2007 Fernando Nasser <fnasser@redhat.com> 0:1.4.1-2.SP8.1jpp.ep1.1
- Rebuild for new release tag

* Wed Dec 12 2007 Fernando Nasser <fnasser@redhat.com> 0:1.4.1-1.SP8.1jpp.ep1.2
- Refresh of SP8 source tar ball (JBCACHE-1165 reverted)

* Wed Dec 12 2007 Fernando Nasser <fnasser@redhat.com> 0:1.4.1-1.SP8.1jpp.ep1.1
- Upgrade to SP8
- Remove patch already included in the sources

* Wed Nov 28 2007 Fernando Nasser <fnasser@redhat.com> 0:1.4.1-1.SP7.1jpp.ep1.3
- Patch for JBCACHE-1225

* Thu Nov 22 2007 Fernando Nasser <fnasser@redhat.com> 0:1.4.1-1.SP7.1jpp.ep1.2
- Fix component-info

* Thu Nov 22 2007 Fernando Nasser <fnasser@redhat.com> 0:1.4.1-1.SP7.1jpp.ep1.1
- Upgrade to SP7

* Thu Nov 01 2007 Fernando Nasser <fnasser@redhat.com> 0:1.4.1-1.SP6.1jpp.ep1.2
- Use new tar ball and rebuild

* Mon Oct 29 2007 Fernando Nasser <fnasser@redhat.com> 0:1.4.1-1.SP6.1jpp.ep1.1
- Upgrade to SP6

* Thu Aug 02 2007 Fernando Nasser <fnasser@redhat.com> 0:1.4.1-1.SP3.1jpp.ep1.1
- Adjust release tag to new guidelines

* Sun Jul 15 2007 Fernando Nasser <fnasser@redhat.com> 0:1.4.1.3-1jpp.ep1.2
- Rebuild

* Mon Jun 25 2007 Fernando Nasser <fnasser@redhat.com> 0:1.4.1.3-1jpp.ep1.1
- Merge with upstream for upgrade
- Add repolib subpackage

* Mon Jun 25 2007 Fernando Nasser <fnasser@redhat.com> 0:1.4.1.3-1jpp
- Upgrade to 1.3.0.SP2

* Thu Jul 13 2006 Fernando Nasser <fnasser@redhat.com> 0:1.3.0.2-1jpp_2rh
- Rebuild with jdk15

* Wed Jun 07 2006 Fernando Nasser <fnasser@redhat.com> 0:1.3.0.2-1jpp_1rh
- Merge for upgrade

* Wed May 31 2006 Ralph Apel <r.apel at r-apel.de> 0:1.3.0.2-1jpp
- Upgrade to 1.3.0.SP2

* Fri May 26 2006 Fernando Nasser <fnasser@redhat.com> 0:1.3.0.1-1jpp_2rh
- Obsolete old jboss4-cache package

* Wed May 24 2006 Fernando Nasser <fnasser@redhat.com> 0:1.3.0.1-1jpp_1rh
- First Red Hat build

* Wed May 03 2006 Ralph Apel <r.apel at r-apel.de> 0:1.3.0.1-1jpp
- First standalone release
